#ifndef INPUT_H
#define INPUT_H

#include "stdbool.h"

typedef enum InputListenerType {
    INPUT_LISTENER_INT,
    INPUT_LISTENER_BOOL,
    INPUT_LISTENER_FLOAT,
} InputListenerType;

typedef void(*IntListener)(int);
typedef void(*BoolListener)(bool);
typedef void(*FloatListener)(float);

typedef struct InputListener {
    void *object;
    InputListenerType type;
    union {
        IntListener int_listener;
        BoolListener bool_listener;
        FloatListener float_listener;
    };
} InputListener;

void InitInputSubmodule();
void CleanInputSubmodule();

void AddListener();
void RemoveListener();

#endif // !INPUT_H
